/******************************************************************************
Source for kclock.dll.
kclock.dll is a digital clock module for the LiteStep shell.

coded from scratch in entirety by pika (that's me).
http://pika.shellscape.org/

Please do not directly use any source code specifically from this document
without giving credit. This is not to say that you're not welcome to use as
much of this code as you'd like, nor is it to say you cannot copy single lines
of code without giving me a one page write up. Use your best judgement.

kclock.h       Header file for the kclock class declarations.
kclock.cpp     Source code for the kclock member functions.

main.h         Main header file. Exports initModuleEx and quitModule.
main.cpp       Main source file. Initializes the module.

bangs.h        Header file for the bang function declarations.
bangs.cpp      Source code for the bang functions definitions.

functions.h    Header file for the utility function declarations.
functions.cpp  Source code for the utility functions. This file.

******************************************************************************/

#include <windows.h>
#include <time.h>
#include <iostream.h>
#include "C:\Microsoft Visual Studio\Ls Projects\IndieStep\lsapi\lsapi.h"

#include "main.h"
#include "Functions.h"
#include "kclock.h"
#include "bangs.h"


// function to return the current time in a formated string
// keeps me from having all of this inside kclock::onPaint()
void GetTimeString(char *copyString, char* format, int adjust) {
    tm *currentTime;
    char timeString[MAX_PATH];
    time_t ltime;

    time(&ltime);
    currentTime = localtime(&ltime);
    currentTime->tm_hour += adjust;
    strftime(timeString, sizeof(timeString)/sizeof(char), format, currentTime);

//    strncpy(copyString, timeString, sizeof(copyString)/sizeof(char));
    strcpy(copyString, timeString);

}


// function to convert a string to a COLORREF value.
// used for the setting bangs
COLORREF StrToCR(char* strColour, bool rgb) {
     char buffer[11];
     COLORREF colour;

     if ( rgb )
          wsprintf(buffer, "0x00%c%c%c%c%c%c", strColour[4], strColour[5], strColour[2], strColour[3], strColour[0], strColour[1]);
     else {
          strcpy(buffer, "0x00");
          strncat(buffer, strColour, 6);
     }

     colour = strtol(buffer, '\0', 0);

     return colour;
}


void StrToRect(char* tmpString, RECT* tmpRect, int w, int h) {
     char *token;

     token = strtok(tmpString, " ");

     if ( token ) {
          tmpRect->left = atoi(token);
          if ( tmpRect->left < 0 )
               tmpRect->left += w;
     }
     token = strtok(NULL, " ");

     if ( token ) {
          tmpRect->top = atoi(token);
          if ( tmpRect->top < 0 )
               tmpRect->top += h;
     }
     token = strtok(NULL, " ");

     if ( token ) {
          tmpRect->right = atoi(token);
          if ( tmpRect->right <= 0 )
               tmpRect->right += w;
     }
     token = strtok(NULL, " ");

     if ( token ) {
          tmpRect->bottom = atoi(token);
          if ( tmpRect->bottom <= 0 )
               tmpRect->bottom += h;
     }
}


// Replaces all instances of searchstring in copystring with replstring
// used for replacing "\n" as two characters with the '\n' character
void ReplaceStr(char *copystring, char *searchstring, char *replstring) {
     char *copy, *posCopyTo, *posCopyFrom, *posSearch;
     int i;

     posCopyFrom = copystring;

     copy = new char[MAX_PATH];
     posCopyTo = copy;

     for ( i = 0; i < (int)strlen(copystring); i++ ) {
          posSearch = strstr(posCopyFrom, searchstring);
          if ( posCopyFrom == posSearch ) {
               strcpy(posCopyTo, replstring);
               posCopyFrom += strlen(searchstring);
               posCopyTo += strlen(replstring);
          }
          else {
               strcpy(posCopyTo, posCopyFrom);
               posCopyFrom++;
               posCopyTo++;
          }
     }

     MessageBox(NULL, copy, "ReplaceStr: copy", 32);

     delete copystring;
     copystring = new char[strlen(copy)+1];
     strcpy(copystring, copy);

     delete copy;

     copy = NULL;
     posCopyFrom = NULL;
     posCopyTo = NULL;
}


// my ultra spiffy gradient routines. Interlaced isn't currently used, maybe in the future.
void horzGradient(COLORREF colorTo, COLORREF colorFrom, HDC hDC, RECT area, bool interlaced) {
     int r1, r2, g1, g2, b1, b2, i, width, height;
     HPEN penNew, penOld;

     r1 = GetRValue(colorFrom);      r2 = GetRValue(colorTo);
     g1 = GetGValue(colorFrom);      g2 = GetGValue(colorTo);
     b1 = GetBValue(colorFrom);      b2 = GetBValue(colorTo);

     width = area.right - area.left;
     height = area.bottom - area.top;

     for ( i = 0; i < width; i++ ) {
          penNew = CreatePen(PS_SOLID, 1,
                             RGB((r1 + ((r2-r1) * i / width)), (g1 + ((g2-g1) * i / width)), (b1 + ((b2-b1) * i / width))));
          penOld = (HPEN)SelectObject(hDC, penNew);

          MoveToEx(hDC, i, 0, NULL);
          LineTo(hDC, i, area.bottom-1);

          SelectObject(hDC, penOld);
          DeleteObject(penNew);
     }

}


void vertGradient(COLORREF colorTo, COLORREF colorFrom, HDC hDC, RECT area, bool interlaced) {
     int r1, r2, g1, g2, b1, b2, i, width, height;
     HPEN penNew, penOld;

     r1 = GetRValue(colorFrom);      r2 = GetRValue(colorTo);
     g1 = GetGValue(colorFrom);      g2 = GetGValue(colorTo);
     b1 = GetBValue(colorFrom);      b2 = GetBValue(colorTo);

     width = area.right - area.left;
     height = area.bottom - area.top;

     for ( i = 0; i < height; i++ ) {
          penNew = CreatePen(PS_SOLID, 1,
                             RGB((r1 + ((r2-r1) * i / height)), (g1 + ((g2-g1) * i / height)), (b1 + ((b2-b1) * i / height))));
          penOld = (HPEN)SelectObject(hDC, penNew);

          MoveToEx(hDC, 0, i, NULL);
          LineTo(hDC, area.right-1, i);

          SelectObject(hDC, penOld);
          DeleteObject(penNew);
     }
}


void diagGradient(COLORREF colorTo, COLORREF colorFrom, HDC hDC, RECT area, bool interlaced) {
     int r1, r2, g1, g2, b1, b2, i, width, height, length, x1=0, x2=-1, y1=0, y2=0;
     HPEN penNew, penOld;

     r1 = GetRValue(colorFrom);      r2 = GetRValue(colorTo);
     g1 = GetGValue(colorFrom);      g2 = GetGValue(colorTo);
     b1 = GetBValue(colorFrom);      b2 = GetBValue(colorTo);

     width = area.right - area.left;
     height = area.bottom - area.top;
     length = width + height;

     for ( i=0; i<length; i++) {
          penNew = CreatePen(PS_SOLID, 1,
                             RGB((r1 + ((r2-r1) * i / length)), (g1 + ((g2-g1) * i / length)), (b1 + ((b2-b1) * i / length))));

          penOld = (HPEN)SelectObject(hDC, penNew);

          MoveToEx(hDC, x1, y1, NULL);
          LineTo(hDC, x2, y2);

          if ( x1 == width )
               y1++;
          else
               x1++;

          if ( y2 == height )
               x2++;
          else
               y2++;

          SelectObject(hDC, penOld);
          DeleteObject(penNew);
    }

}