/******************************************************************************
Source for kclock.dll.
kclock.dll is a digital clock module for the LiteStep shell.

coded from scratch in entirety by pika (that's me).
http://pika.shellscape.org/

Please do not directly use any source code specifically from this document
without giving credit. This is not to say that you're not welcome to use as
much of this code as you'd like, nor is it to say you cannot copy single lines
of code without giving me a one page write up. Use your best judgement.

functions.h    Header file for the utility function declarations.
functions.cpp  Source code for the utility functions.

main.h         Main header file. Exports initModuleEx and quitModule.
main.cpp       Main source file. Initializes the module.

bangs.h        Header file for the bang function declarations.
bangs.cpp      Source code for the bang functions definitions.

kclock.h       Header file for the kclock class declarations.
kclock.cpp     Source code for the kclock member functions. This file.

******************************************************************************/

#include <windows.h>
#include <time.h>
#include <iostream.h>
#include "C:\Microsoft Visual Studio\Ls Projects\IndieStep\lsapi\lsapi.h"

#include "main.h"
#include "Functions.h"
#include "kclock.h"
#include "bangs.h"


char versionInfo[] = "$Id: kclock2.dll: v1.6 (pika)";


// A dummy message handler to route all messages to kclock member functions.
LRESULT CALLBACK kProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
     int code;

    switch ( msg ) {

     case WM_CREATE:
          kClock->onCreate(hWnd, wParam, lParam);
          break;
/*
     case WM_WINDOWPOSCHANGED:
          MessageBox(NULL, "WM_WINDOWPOSCHANGED", "WM_WINDOWPOSCHANGED", 32);
//          InvalidateRect(hWnd, NULL, true);
          break;
*/
     case WM_PAINT:
          kClock->onPaint(hWnd, wParam, lParam);
          break;

     case WM_TIMER:
          kClock->onTimer(hWnd, wParam, lParam);
          break;

     case WM_LBUTTONDOWN:
          kClock->onLeftBtnDown(hWnd, wParam, lParam);
          break;

     case WM_LBUTTONUP:
          kClock->onLeftBtnUp(hWnd, wParam, lParam);
          break;

     case WM_RBUTTONDOWN:
          kClock->onRightBtnDown(hWnd, wParam, lParam);
          break;

     case WM_RBUTTONUP:
          kClock->onRightBtnUp(hWnd, wParam, lParam);
          break;

     case WM_MBUTTONDOWN:
          kClock->onMiddleBtnDown(hWnd, wParam, lParam);
          break;

     case WM_MBUTTONUP:
          kClock->onMiddleBtnUp(hWnd, wParam, lParam);
          break;

     case WM_MOUSEMOVE:
          kClock->onMouseMove(hWnd, wParam, lParam);
          break;

     case WM_DESTROY:
          code = kClock->onDestroy(hWnd, wParam, lParam);
//          if ( code ) {
//               if ( kClock )
//                    delete kClock;
//          }

          return code;
          break;

     case LM_REFRESH:
          kClock->onRefresh(hWnd, wParam, lParam);
          break;

     case LM_GETREVID:
          kClock->onGetRevId(hWnd, wParam, lParam);
          return strlen((char*)lParam);
          break;

    default:
        return DefWindowProc(hWnd, msg, wParam, lParam);
        break;
    }

    return 0;
}

kclock::kclock(HINSTANCE dllInst2, int &code) {
     WNDCLASSEX kClass;
     HWND desktopWnd;
     int msgs[] = {LM_GETREVID, LM_REFRESH, 0};
     char kClassName[] = "kclock";
     char errorCode[256];

     dllInst = dllInst2;
     desktopWnd = FindWindow("DesktopBackgroundClass", NULL);
     if (!desktopWnd)
         desktopWnd = GetDesktopWindow();

     // calls config to read the step settings and configfunctable for the set bangs
     Config();
     ConfigFuncTable();

     kClass.cbSize        = sizeof(WNDCLASSEX);
     kClass.hInstance     = dllInst;
     kClass.lpfnWndProc   = kProc;
     kClass.lpszClassName = kClassName;
     kClass.lpszMenuName  = NULL;
     kClass.style         = CS_HREDRAW | CS_VREDRAW;
     kClass.cbClsExtra    = 0;
     kClass.cbWndExtra    = 0;
     kClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
     kClass.hIcon         = NULL;
     kClass.hIconSm       = NULL;
     kClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);

     if ( !RegisterClassEx(&kClass) )
          MessageBox(NULL, "Error registering class.", "Error: Constructor", 32);


     kWnd = CreateWindowEx( /*winStyle,*/ ( onTop ? WS_EX_TOPMOST : NULL) | WS_EX_TOOLWINDOW,
                            kClassName, kClassName, (onBottom && !onTop ? WS_CHILD : NULL) | WS_POPUP,
                            x, y, w, h, (onBottom && !onTop ? desktopWnd : GetLitestepWnd()), NULL, dllInst, NULL);


     if ( !kWnd ) {
          itoa(GetLastError(), errorCode, 16);
          MessageBox(NULL, errorCode, "Error: Constructor", 32);
     }

     SetWindowLong(kWnd, GWL_USERDATA, magicDWord);
     SendMessage(GetLitestepWnd(), LM_REGISTERMESSAGE, (WPARAM)kWnd, (LPARAM)msgs);
     RegisterBangs();

     if ( backBmp )
          SetWindowRgn(kWnd, kRgn, true);

     if ( !waitForBox )
          ShowWindow(kWnd, (hidden ? SW_HIDE : SW_SHOWNOACTIVATE));

     if ( !SetTimer(kWnd, TIMER_UPDATE, interval, NULL) )
          MessageBox(NULL, "Unable to set timer.", "Error", 32);
}


kclock::~kclock() {
     int msgs[] = {LM_GETREVID, LM_REFRESH, 0};
	SendMessage(GetLitestepWnd(), LM_UNREGISTERMESSAGE, (WPARAM)kWnd, (LPARAM)msgs);

	KillTimer(kWnd, TIMER_UPDATE);

     deleteObjects();

     RemoveBangCommand("!kclockExecute");
     RemoveBangCommand("!kclockHide");
     RemoveBangCommand("!kclockLeftClick");
     RemoveBangCommand("!kclockMiddleClick");
     RemoveBangCommand("!kclockMove");
     RemoveBangCommand("!kclockRightClick");
     RemoveBangCommand("!kclockSet");
     RemoveBangCommand("!kclockShow");
     RemoveBangCommand("!kclockToggle");
     RemoveBangCommand("!kclockForceUpdate");
     RemoveBangCommand("!kclockBoxHook");
	
     if ( IsWindow(kWnd) )
          DestroyWindow(kWnd);

     if ( !UnregisterClass("kclock", dllInst) )
          MessageBox(NULL, "Could not unregister the class.", "Error: Destructor", 32);
}


void kclock::Config() {
     char /**token,*/ tmpString[MAX_PATH];
     bool tmpBool;
     int tmpInt;
     LOGFONT lFont;

     // Initializes char pointers to NULL.
     format = NULL;
     fontFace = NULL;
     leftClick = NULL;
     rightClick = NULL;
     middleClick = NULL;
     backFile = NULL;

     // Coordinates, Border, Dimensions, and Update Interval.
     GetRCString("kclockX", tmpString, "0", sizeof(tmpString)/sizeof(char));
     if ( strchr(strlwr(tmpString), 'c') )
          x = (GetSystemMetrics(SM_CXSCREEN) / 2) + atoi(tmpString);
     else {
          x = atoi(tmpString);
          if ( x < 0 )
               x += GetSystemMetrics(SM_CXSCREEN);
     }

     GetRCString("kclockY", tmpString, "0", sizeof(tmpString)/sizeof(char));
     if ( strchr(strlwr(tmpString), 'c') )
          y = (GetSystemMetrics(SM_CYSCREEN) / 2) + atoi(tmpString);
     else {
          y = atoi(tmpString);
          if ( y < 0 )
               y += GetSystemMetrics(SM_CYSCREEN);
     }

     w = GetRCInt("kclockWidth", 50);
     h = GetRCInt("kclockHeight", 25);

     timeChange    = GetRCInt("kclockTimeChange", 0);
     interval      = GetRCInt("kclockInterval", 1000);
     tmpInt        = GetRCInt("kclockBorder", 1);
     border.left   = GetRCInt("kclockBorderLeft", tmpInt);
     border.top    = GetRCInt("kclockBorderTop", tmpInt);
     border.right  = GetRCInt("kclockBorderRight", tmpInt);
     border.bottom = GetRCInt("kclockBorderBottom", tmpInt);

     // boolean values needed for kclock
     onTop      = GetRCBoolDef("kclockOnTop", false) == 1;
     onBottom   = GetRCBoolDef("kclockOnBottom", false) == 1;
     hidden     = GetRCBoolDef("kclockHidden", false) == 1;
     textBold   = GetRCBoolDef("kclockBold", false) == 1;
     textItalic = GetRCBoolDef("kclockItalic", false) == 1;
     textShadow = GetRCBoolDef("kclockTextShadow", false) == 1;
     bmpTile    = GetRCBoolDef("kclockBmpTile", false) == 1;
     bmpStretch = GetRCBoolDef("kclockBmpStretch", false) == 1;
//   transText  = GetRCBoolDef("kclockTransparent", false) == 1;
     borderDrag = GetRCBoolDef("kclockBorderDrag", false) ==1;
     waitForBox = GetRCBoolDef("kclockInBox", false) ==1;
     inBox      = false;
     mouseDrag  = false;
     mouseOver  = false;

//     if ( onTop )
//          winStyle = WS_EX_TOPMOST | WS_EX_TOOLWINDOW;

//     if ( transText )
//          winStyle |= WS_EX_TRANSPARENT;

     // Color values.
     bgColor         = GetRCColor("kclockBg", GetSysColor(COLOR_BTNFACE));
     bgColorTo       = GetRCColor("kclockBgTo", bgColor);
     hilightColor    = GetRCColor("kclockHilight", GetSysColor(COLOR_BTNHILIGHT));
     shadowColor     = GetRCColor("kclockShadow", GetSysColor(COLOR_BTNSHADOW));
     textColor       = GetRCColor("kclockText", GetSysColor(COLOR_BTNTEXT));
     textShadowColor = GetRCColor("kclockTextShadowClr", GetSysColor(COLOR_BTNSHADOW));
     textShadowOff   = GetRCInt("kclockTextShadowOff", 1);

     // Gets rotate info.
/*     GetRCString("kclockRotate", tmpString, "none", sizeof(tmpString)/sizeof(char));
     strlwr(tmpString);
     if ( !strcmp(tmpString, "left") )
          rotateI = 900;
     else {
          if ( !strcmp(tmpString, "right") )
               rotateI = 1800;
          else
               rotateI = 0;
     }
*/
     // Gets justification info
     GetRCString("kclockTextJustify", tmpString, "center", sizeof(tmpString)/sizeof(char));
     strlwr(tmpString);
     if ( !strcmp(tmpString, "left") )
          textJustify = DT_VCENTER | DT_LEFT;
     else if ( !strcmp(tmpString, "right") )
          textJustify = DT_VCENTER | DT_RIGHT;
     else
          textJustify = DT_VCENTER | DT_CENTER;

     // Gets font name and initializes font. Defaults to Arial.
     memset(&lFont, 0, sizeof(LOGFONT));

     fontHeight = GetRCInt("kclockFontSize", 12);
     GetRCString("kclockFont", tmpString, "Arial", sizeof(tmpString)/sizeof(char));
     fontFace = new char[32];
     strncpy(fontFace, tmpString, 32);
     strncpy(lFont.lfFaceName, tmpString, 32);

     lFont.lfItalic       = textItalic;
     lFont.lfWeight       = (textBold ? FW_BOLD : FW_NORMAL);
     lFont.lfHeight       = fontHeight;
//     lFont.lfStrikeOut    = false;
//     lFont.lfUnderline    = false;
//     lFont.lfEscapement   = 0;
//     lFont.lfOrientation  = 0;
//     lFont.lfCharSet      = ANSI_CHARSET;
//     lFont.lfOutPrecision = OUT_STRING_PRECIS;

     hFont = CreateFontIndirect(&lFont);

     // Use a bitmap, or set it to NULL
     tmpBool = GetRCBoolDef("kclockBack", false) == 1;
     if ( tmpBool ) {
          GetRCString("kclockBack", tmpString, ".none", sizeof(tmpString)/sizeof(char));
          if ( strcmp(tmpString, ".none") ) {
               backFile = new char[strlen(tmpString)+1];
               strcpy(backFile, tmpString);
               backBmp = LoadLSImage(backFile, NULL);
               if ( backBmp ) {
                    GetLSBitmapSize(backBmp, &bw, &bh);
                    if ( !bmpTile && !bmpStretch ) {
                         w = bw;
                         h = bh;
                         kRgn = BitmapToRegion(backBmp, RGB(255, 0, 255), 0x101010, 0, 0);
                    }
               }
          }
     }
     else {
          backBmp = NULL;
          if ( !transText )
               kRgn = CreateRectRgn(0, 0, w, h);
     }

     // Retrieves the display rect
     display.left   = 0;
     display.top    = 0;
     display.right  = w;
     display.bottom = h;

     GetRCLine("kclockDispRect", tmpString, sizeof(tmpString)/sizeof(char), "0 0");
     StrToRect(tmpString, &(this->display), this->w, this->h);
/*
     if ( strcmp(tmpString, "\0") ) {
          token = strtok(tmpString, " ");
          if ( token ) {
               display.left = atoi(token);
               if ( display.left < 0 )
                    display.left += w;
          }
          token = strtok(NULL, " ");
          if ( token ) {
               display.top = atoi(token);
               if ( display.top < 0 )
                    display.top += h;
          }
          token = strtok(NULL, " ");
          if ( token ) {
               display.right = atoi(token);
               if ( display.right <= 0 )
                    display.right += w;
          }
          token = strtok(NULL, " ");
          if ( token ) {
               display.bottom = atoi(token);
               if ( display.bottom <= 0 )
                    display.bottom =+ h;
          }
     }
*/
     // Set up the client rect.
     client.left   = border.left;
     client.top    = border.top;
     client.right  = w - border.right;
     client.bottom = h - border.bottom;

     // Set up the gradient type (in the case of gradients)
     GetRCString("kclockGradType", tmpString, "vertical", sizeof(tmpString)/sizeof(char));
     gradType = new char[strlen(tmpString)+1];
     strcpy(gradType, tmpString);

     // Set up the format
     GetRCString("kclockFormat", tmpString, "%H:%M:%S", sizeof(tmpString)/sizeof(char));
     format = new char[strlen(tmpString)+1];
     strcpy(format, tmpString);
     if ( strstr(format, "\\n") )
          ReplaceStr(format, "\\n", "\n");
     else
          textJustify = textJustify | DT_SINGLELINE;

     // Set the left click action.
     GetRCString("kclockLeftClick", tmpString, "!none", sizeof(tmpString)/sizeof(char));
     leftClick = new char[strlen(tmpString)+1];
     strcpy(leftClick, tmpString);

     // Set the right click action.
     GetRCString("kclockRightClick", tmpString, "!popup", sizeof(tmpString)/sizeof(char));
     rightClick = new char[strlen(tmpString)+1];
     strcpy(rightClick, tmpString);

     // Set the middle click action.
     GetRCString("kclockMiddleClick", tmpString, "!none", sizeof(tmpString)/sizeof(char));
     middleClick = new char[strlen(tmpString)+1];
     strcpy(middleClick, tmpString);

     // Set the mouse enter action.
     GetRCString("kclockMouseEnter", tmpString, "!none", sizeof(tmpString)/sizeof(char));
     mouseEnter = new char[strlen(tmpString)+1];
     strcpy(mouseEnter, tmpString);

     // Set the mouse exit action.
     GetRCString("kclockMouseExit", tmpString, "!none", sizeof(tmpString)/sizeof(char));
     mouseExit = new char[strlen(tmpString)+1];
     strcpy(mouseExit, tmpString);
}


void kclock::ConfigFuncTable() {
     // this sets up the Functions table for the setting bangs
	SetFunctionsTable[0].function = bangSetFormat;
	SetFunctionsTable[0].setting = "format";

	SetFunctionsTable[1].function = bangSetBack;
	SetFunctionsTable[1].setting = "back";

	SetFunctionsTable[2].function = bangSetColor;
	SetFunctionsTable[2].setting = "textcolor";

	SetFunctionsTable[3].function = bangSetBgColor;
	SetFunctionsTable[3].setting = "bgcolor";

     SetFunctionsTable[4].function = bangSetBgColorTo;
     SetFunctionsTable[4].setting = "bgcolorto";

	SetFunctionsTable[5].function = bangSetHilight;
	SetFunctionsTable[5].setting = "hilight";

	SetFunctionsTable[6].function = bangSetShadow;
	SetFunctionsTable[6].setting = "shadow";

	SetFunctionsTable[7].function = bangSetTextShadow;
	SetFunctionsTable[7].setting = "textshadow";

	SetFunctionsTable[8].function = bangSetTextShadowClr;
	SetFunctionsTable[8].setting = "textshadowclr";

	SetFunctionsTable[9].function = bangSetTextShadowOff;
	SetFunctionsTable[9].setting = "textshadowoff";

	SetFunctionsTable[10].function = bangSetLeftClick;
	SetFunctionsTable[10].setting = "leftclick";

	SetFunctionsTable[11].function = bangSetRightClick;
	SetFunctionsTable[11].setting = "rightclick";

	SetFunctionsTable[12].function = bangSetMiddleClick;
	SetFunctionsTable[12].setting = "middleclick";

     SetFunctionsTable[13].function = bangSetOnTop;
     SetFunctionsTable[13].setting = "ontop";

     SetFunctionsTable[14].function = bangSetOnBottom;
     SetFunctionsTable[14].setting = "onbottom";

     SetFunctionsTable[15].function = bangSetTimeChange;
     SetFunctionsTable[15].setting = "timechange";

     SetFunctionsTable[16].function = bangSetMouseEnter;
     SetFunctionsTable[16].setting = "mouseenter";

     SetFunctionsTable[17].function = bangSetMouseExit;
     SetFunctionsTable[17].setting = "mouseexit";

     SetFunctionsTable[18].function = bangSetBorderDrag;
     SetFunctionsTable[18].setting = "borderdrag";

     SetFunctionsTable[19].function = bangSetDispRect;
     SetFunctionsTable[19].setting = "disprect";
}


void kclock::deleteObjects() {

     delete format;
     delete fontFace;
     delete leftClick;
     delete rightClick;
     delete middleClick;
     delete mouseEnter;
     delete mouseExit;
     delete backFile;
     delete gradType;


     DeleteObject(backBmp);
     DeleteObject(hFont);
     DeleteObject(kRgn);
}


void kclock::RegisterBangs() {
     AddBangCommand("!kclockExecute", bangExecute);
     AddBangCommand("!kclockHide", bangHide);
     AddBangCommand("!kclockLeftClick", bangLeftClick);
     AddBangCommand("!kclockMiddleClick", bangMiddleClick);
     AddBangCommand("!kclockMove", bangMove);
     AddBangCommand("!kclockRightClick", bangRightClick);
     AddBangCommand("!kclockSet", bangSet);
     AddBangCommand("!kclockShow", bangShow);
     AddBangCommand("!kclockToggle", bangToggle);
     AddBangCommand("!kclockForceUpdate", bangForceUpdate);
     AddBangCommand("!kclockBoxHook", bangBoxHook);
}


// Message functions for the dummy WndProc
void kclock::onCreate(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     // this message does not currently execute any real response.
//     InvalidateRect(kWnd, NULL, true);
}


int kclock::onDestroy(HWND hWnd, WPARAM wParam, LPARAM lParam) {
//     MessageBox(NULL, "WM_DESTROY message received.", "kclock::onDestroy", 32);
     if ( inBox ) {
          SetWindowLong(kWnd, GWL_STYLE, (GetWindowLong(kWnd, GWL_STYLE) &~ WS_CHILD)|WS_POPUP);
          SetParent(kWnd, 0);
          ShowWindow(kWnd, SW_HIDE);
          inBox = false;
          return 0;
     }
     else
          return 1;
//     else
//	     PostQuitMessage(0);
//          PostMessage(kWnd, WM_QUIT, 0, NULL);
}


void kclock::onPaint(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     int i;
     HDC paintDC, bmpDC;
     PAINTSTRUCT ps;
     HBRUSH backBrush;
     HPEN oldPen, hiPen, lowPen;
     HFONT oldFont;
     RECT clientRect, textRect, shadowRect;
     char timeString[128];
     HBITMAP oldBmp;

     // creates the brushes and pens used for drawing.
     backBrush = CreateSolidBrush(bgColor);
     hiPen = CreatePen(PS_SOLID, 1, hilightColor);
     lowPen = CreatePen(PS_SOLID, 1, shadowColor);

     GetClientRect(hWnd, &clientRect);
     paintDC = BeginPaint(hWnd, &ps);

     // if backBmp isn't set up, use the GDI functions
     if ( !backBmp /*&& !transText*/ ) {        

          // if bgColor and bgColorTo are the same, just fill the window
          if ( bgColor == bgColorTo )
               FillRect(paintDC, &clientRect, backBrush);

          // if they aren't, decide the type of gradient and draw it.
          else {
               if ( !strcmp(gradType, "diagonal") )
                    diagGradient(bgColorTo, bgColor, paintDC, clientRect, false);
               else if ( !strcmp(gradType, "horizontal") )
                    horzGradient(bgColorTo, bgColor, paintDC, clientRect, false);
               else
                    vertGradient(bgColorTo, bgColor, paintDC, clientRect, false);
          }

          // Draw the left and top borders
          oldPen = (HPEN)SelectObject(paintDC, hiPen);
          for ( i=0; i<kclock::border.left; i++ ) {
               MoveToEx(paintDC, i, 0, NULL);
               LineTo(paintDC, i, clientRect.bottom - i);
          }

          for ( i=0; i<border.top; i++ ) {
               MoveToEx(paintDC, 0, i, NULL);
               LineTo(paintDC, clientRect.right, i);
          }

          // Draw the right and bottom borders
          SelectObject(paintDC, lowPen);
          for ( i=0; i<border.right; i++ ) {
               MoveToEx(paintDC, clientRect.right-1-i, i, NULL);
               LineTo(paintDC, clientRect.right-1-i, clientRect.bottom);
          }

          for ( i=0; i<border.bottom; i++ ) {
               MoveToEx(paintDC, i, clientRect.bottom-1-i, NULL);
               LineTo(paintDC, clientRect.right, clientRect.bottom-1-i);
          }

          SelectObject(paintDC, oldPen);
     }

     // otherwise, draw the bitmap onto the window.
     // paintDC is the dc of the window. bmpDC is the HDC used to hold the bitmap image.
     else {
          bmpDC = CreateCompatibleDC(paintDC);
          oldBmp = (HBITMAP)SelectObject(bmpDC, backBmp);

//          SetWindowRgn(kWnd, kRgn, false);

          if ( bmpTile || bmpStretch ) {
               if ( bmpTile ) {
                    int i, j;
                    for ( i=0; i<h; ) {
                         for ( j=0; j<=w; ) {
                              BitBlt(paintDC, (j+border.left), (i+border.top), (bw-border.left-border.right), (bh-border.top-border.bottom),
                                     bmpDC, border.left, border.right, SRCCOPY);
//                              BitBlt(paintDC, (j+border.left), (i+border.top), ((w-j-border.right)>bw ? (w-j-border.right) : bw), ((h-i-border.bottom)>bh ? (h-i-border.bottom) : bh),
//                                     bmpDC, border.left, border.right, SRCCOPY
                              j+=(bw-border.left-border.right);
                         }
                         i+=(bh-border.top-border.bottom);
                    }

                    // Top and bottom borders
                    for ( i=0; i<w; ) {
                         BitBlt(paintDC, (i+border.left), 0, (bw-border.left-border.right), border.top,
                                bmpDC, border.left, 0, SRCCOPY);
                         BitBlt(paintDC, (i+border.left), (h-border.bottom), (bw-border.left-border.right), border.bottom,
                                bmpDC, border.left, bh-border.bottom, SRCCOPY);
                         i+=(bw-border.left-border.right);
                    }

                    // Left and right borders
                    for ( i=0; i<h; ) {
                         BitBlt(paintDC, 0, (i+border.top), border.left, (bh-border.top-border.bottom),
                                bmpDC, 0, border.top, SRCCOPY);
                         BitBlt(paintDC, (w-border.right), (i+border.top), border.right, (bh-border.top-border.bottom),
                                bmpDC, (bw-border.right), border.top, SRCCOPY);
                         i+=(bh-border.top-border.bottom);
                    }
               }

               else {
                    StretchBlt(paintDC, border.left, border.top, (w-border.left-border.right), (h-border.top-border.bottom),
                               bmpDC, border.left, border.top, (bw-border.left-border.right), (bh-border.top-border.bottom), SRCCOPY);
                    // Left border
                    StretchBlt(paintDC, 0, border.top, border.left, (h-border.top-border.bottom),
                               bmpDC, 0, border.top, border.left, (bh-border.top-border.bottom), SRCCOPY);
                    // Right border
                    StretchBlt(paintDC, (w-border.right), border.top, (w-border.right), (h-border.top-border.bottom),
                               bmpDC, (bw-border.right), border.top, border.right, (bh-border.top-border.bottom), SRCCOPY);
                    // Top border
                    StretchBlt(paintDC, border.left, 0, (w-border.right-border.left), border.top,
                               bmpDC, border.left, 0, (bw-border.right-border.left), border.top, SRCCOPY);
                    // Bottom border
                    StretchBlt(paintDC, border.left, (h-border.bottom), (w-border.left-border.right), border.bottom,
                               bmpDC, border.left, (bh-border.bottom), (bw-border.left-border.right), border.bottom, SRCCOPY);
               }

               // Top left corner
               BitBlt(paintDC, 0, 0, border.left, border.top,
                      bmpDC, 0, 0, SRCCOPY);
               // Bottom left corner
               BitBlt(paintDC, 0, (h-border.bottom), border.left, border.bottom,
                      bmpDC, 0, (bh-border.bottom), SRCCOPY);
               // Top right corner
               BitBlt(paintDC, (w-border.right), 0, border.right, border.top,
                      bmpDC, (bw-border.right), 0, SRCCOPY);
               // Bottom right corner
               BitBlt(paintDC, (w-border.right), (h-border.bottom), border.right, border.bottom,
                      bmpDC, (bw-border.right), (bh-border.bottom), SRCCOPY);
          }

          else {
               TransparentBltLS(paintDC, 0, 0, w, h, bmpDC, 0, 0, RGB(255, 0, 255));
          }
          SelectObject(bmpDC, oldBmp);
          DeleteDC(bmpDC);
     }

     oldFont = (HFONT)SelectObject(paintDC, hFont);

     SetBkMode(paintDC, TRANSPARENT);
     GetTimeString(timeString, this->format, timeChange);
     timeString[strlen(timeString)] = '\0';
     
     textRect = display;
     if ( textShadow ) {
          shadowRect = display;
          shadowRect.left += textShadowOff;
          shadowRect.top += textShadowOff;

          textRect.right += -(textShadowOff);
          textRect.bottom += -(textShadowOff);
               
          SetTextColor(paintDC, textShadowColor);
//          DrawText(paintDC, timeString, strlen(timeString), &shadowRect, textJustify | DT_CALCRECT);
//          DrawText(paintDC, timeString, strlen(timeString), &shadowRect, textJustify);
//          DrawTextEx(paintDC, timeString, strlen(timeString), &shadowRect, textJustify | DT_CALCRECT, 0);
          DrawTextEx(paintDC, timeString, strlen(timeString), &shadowRect, textJustify, NULL);
     }

     SetTextColor(paintDC, textColor);
//     DrawText(paintDC, timeString, strlen(timeString), &textRect, textJustify | DT_CALCRECT);
//     DrawText(paintDC, timeString, strlen(timeString), &textRect, textJustify);
//     DrawTextEx(paintDC, timeString, strlen(timeString), &textRect, textJustify | DT_CALCRECT, 0);
     DrawTextEx(paintDC, timeString, strlen(timeString), &textRect, textJustify, NULL);

     SelectObject(paintDC, oldFont);

     // deletes the objects used for drawing (except the font, of course)
     DeleteObject(hiPen);
     DeleteObject(lowPen);
     DeleteObject(backBrush);

     EndPaint(hWnd, &ps);
}


void kclock::onTimer(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     // forces the window to redraw itself on the timer
     InvalidateRect(hWnd, NULL, false);
}


void kclock::onRefresh(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     RECT windowRect;
     // Rereads in the configurations and invalidates the window
     deleteObjects();
	Config();

     GetWindowRect(kWnd, &windowRect);
     x = windowRect.left;
     y = windowRect.top;


     if ( ( GetWindowLong(kWnd, GWL_EXSTYLE) & WS_EX_TOPMOST )  ) {
          if ( !onTop )
               SetWindowLong(kWnd, GWL_EXSTYLE, WS_EX_TOOLWINDOW);
     }
     else {
          if ( onTop ) {
               SetWindowLong(kWnd, GWL_EXSTYLE, GetWindowLong(kWnd, GWL_EXSTYLE) | WS_EX_TOPMOST);
               SetWindowLong(kWnd, GWL_STYLE, (GetWindowLong(kWnd, GWL_STYLE) & ~WS_CHILD) | WS_POPUP);
          }
     }


     if ( ( GetWindowLong(kWnd, GWL_STYLE) & WS_CHILD ) ) {
          if ( !onBottom )
               SetWindowLong(kWnd, GWL_STYLE, (GetWindowLong(kWnd, GWL_STYLE) & ~WS_CHILD) | WS_POPUP);
     }
     else {
          if ( onBottom ) {
               SetWindowLong(kWnd, GWL_STYLE, WS_CHILD | WS_POPUP);
               SetParent(kWnd, desktopWnd);
          }
     }

     MoveWindow(kWnd, x, y, w, h, true);
     SetWindowPos(kWnd, (onTop ? HWND_TOPMOST : HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
     SetWindowRgn(kWnd, kRgn, true);

	InvalidateRect(kWnd, NULL, true);
}


void kclock::onGetRevId(HWND hWnd, WPARAM wParam, LPARAM lParam) {
	char* buf;
	buf = (char*)lParam;

	switch ( wParam ) {

	case 0:
          // prints the rev id to the pointer provided by lParam
          // to be honest i'm not entirely certain how this works.
		sprintf(buf, &versionInfo[5]);
		buf[strlen(buf)] = '\0';
		break;

	case 1:
		sprintf(buf, versionInfo);
		buf[strlen(buf)] = '\0';
		break;

	default:
		strcpy(buf, "");
		break;
	}

}


void kclock::onLeftBtnDown(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     // checks to see if if border drag is turned on
     if ( borderDrag ) {
          // sets up the current cursor position
          GetCursorPos(&this->mousePos);
          // Evaluates whether the cursor is inside the border or not
          if ( (mousePos.x < (x + border.left)) || (mousePos.x > (x + client.right - border.right)) ||
               (mousePos.y < (y + border.top)) || (mousePos.y > (y + client.bottom - border.bottom)) ) {

               // sets mouseDrag to true and captures the mouse
	          mouseDrag = true;
               SetCapture(kWnd);
          }
     }
}


void kclock::onLeftBtnUp(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     char cX[8], cY[8];
     // if mouseDrag is on, releases the mouse, sets mouseDrag to false, and returns without
     // executing the left click command.
     if ( mouseDrag ) {
          mouseDrag = false;
//          ReleaseCapture();
          return;
          itoa(this->x, cX, 10);
          itoa(this->y, cY, 10);

          LSSetVariable("kclockX", cX);
          LSSetVariable("kclockY", cY);
     }

     if ( leftClick )
          LSExecute(kWnd, leftClick, 0);
}


void kclock::onRightBtnDown(HWND hWnd, WPARAM wParam, LPARAM lParam) {
}


void kclock::onRightBtnUp(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     if ( rightClick )
          LSExecute(kWnd, rightClick, 0);
}


void kclock::onMiddleBtnDown(HWND hWnd, WPARAM wParam, LPARAM lParam) {
}


void kclock::onMiddleBtnUp(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     if ( middleClick )
          LSExecute(kWnd, middleClick, 0);
}


void kclock::onMouseMove(HWND hWnd, WPARAM wParam, LPARAM lParam) {
     POINT mousePosNew;
     RECT windowRect;
     int newX, newY;

     GetCursorPos(&mousePosNew);

     if ( mouseDrag ) {
          // newX and newY are the current coordinates of the window.
          newX = x;
          newY = y;
          // newX and newY are adjusted according to the difference of the cursor position
          newX += (mousePosNew.x - mousePos.x);
          newY += (mousePosNew.y - mousePos.y);

          // Checks to see if the window would move outside of the screen.
          if ( newX < 0 )
               newX = 0;

          if ( newY < 0 )
               newY = 0;

          if ( (newX + w) > GetSystemMetrics(SM_CXSCREEN) )
               newX = GetSystemMetrics(SM_CXSCREEN) - w;

          if ( (newY + h) > GetSystemMetrics(SM_CYSCREEN) )
               newY = GetSystemMetrics(SM_CYSCREEN) - h;

          // Moves the window. Sets mouseDrag false, so as not to trigger false positives on WM_MOUSEMOVE
          mouseDrag = false;
          MoveWindow(kWnd, newX, newY, w, h, true);
          mouseDrag = true;

          // Resets the current mousePos and x and y coordinates
          mousePos = mousePosNew;
          x = newX;
          y = newY;
     }

     else if ( mouseOver ) {
          GetWindowRect(kWnd, &windowRect);

          windowRect.left += border.left;
          windowRect.top += border.top;
          windowRect.right -= border.right;
          windowRect.bottom -= border.bottom;

          if ( !PtInRect(&windowRect, mousePosNew) ) {
               ReleaseCapture();
               LSExecute(kWnd, mouseExit, 0);
               mouseOver = false;
          }
     }

     else if ( !mouseOver ) {
          GetWindowRect(kWnd, &windowRect);

          windowRect.left += border.left;
          windowRect.top += border.top;
          windowRect.right -= border.right;
          windowRect.bottom -= border.bottom;

          if ( PtInRect(&windowRect, mousePosNew) ) {
               mouseOver = true;
               SetCapture(kWnd);
               LSExecute(kWnd, mouseEnter, 0);
          }
     }
}


// Bang command functions
void kclock::kclockBoxHook(HWND caller, LPCSTR args) {
     if ( waitForBox ) {
          inBox = true;
          char *token, boxFile[MAX_PATH], handle[32];
          HWND boxWnd;
          int msgs[] = {LM_GETREVID, LM_REFRESH, 0};

          token = strtok((char*)args, " ");
          while ( token ) {
               strcpy(boxFile, handle);
               strcpy(handle, token);
               token = strtok(NULL, " ");
          }

          boxWnd = (HWND)atoi(handle);

          if ( IsWindow(boxWnd) ) {
               SetWindowLong(kWnd, GWL_STYLE, (GetWindowLong(kWnd, GWL_STYLE) &~ WS_POPUP)|WS_CHILD);
               SetParent(kWnd, boxWnd);

               ShowWindow(kWnd, SW_SHOWNOACTIVATE);

               InvalidateRect(kWnd, NULL, false);
          }

          else {
               MessageBox(NULL, "boxWnd invalid", "kClock2 Error", 32);
          }

     }
}


void kclock::kclockExecute(HWND caller, LPCSTR args) {
     char *execString=new char[MAX_PATH];
     GetTimeString(execString, (char*)args, timeChange);

     LSExecute(NULL, execString, 0);

}

void kclock::kclockHide(HWND caller, LPCSTR args) {
     if ( IsWindowVisible(kWnd) ) {
          ShowWindow(kWnd, SW_HIDE);
          hidden = true;
     }
}

void kclock::kclockLeftClick(HWND caller, LPCSTR args) {
     if ( leftClick )
          LSExecute(NULL, leftClick, 0);
}

void kclock::kclockMiddleClick(HWND caller, LPCSTR args) {
     if ( middleClick )
          LSExecute(NULL, middleClick, 0);
}

void kclock::kclockMove(HWND caller, LPCSTR args) {
     char *token, tmpString[64], cX[8], cY[8], cW[8], cH[8];

     token = strtok((char*)args, " ");
     if ( token ) {
          strlwr(token);

          if ( strcmp(token, "x") ) {

               if ( strchr(token, '+') ) {
                    if ( strstr(token, "+-") ) {
                         x += atoi(token + sizeof(char));
                    }
                    else
                         x += atoi(token);
               }
               else {
                    x = atoi(token);
                    if ( x < 0 )
                         x += GetSystemMetrics(SM_CXSCREEN);
               }
          }
     }

     token = strtok(NULL, " ");
     if ( token ) {
          strlwr(token);

          if ( strcmp(token, "y") ) {

               if ( strchr(token, '+') ) {
                    if ( strstr(token, "+-") )
                         y += atoi(token + sizeof(char));
                    else
                         y += atoi(token);
               }
               else {
                    y = atoi(token);
                    if ( y < 0 )
                         y += GetSystemMetrics(SM_CYSCREEN);
               }
          }
     }


     if ( !backBmp || (bmpTile || bmpStretch) ) {

          token = strtok(NULL, " ");
          if ( token ) {
               strlwr(token);

               if ( strcmp(token, "w") ) {

                    if ( strchr(token, '+') ) {
                         if ( strstr(token, "+-") )
                              w += atoi(token + sizeof(char));
                         else
                              w += atoi(token);
                    }
                    else
                         w = atoi(token);
               }
          }

          token = strtok(NULL, " ");
          if ( token ) {
               strlwr(token);

               if ( strcmp(token, "h") ) {

                    if ( strchr(token, '+') ) {
                         if ( strstr(token, "+-") )
                              h += atoi(token + sizeof(char));
                         else
                              h += atoi(token);
                    }
                    else
                         h = atoi(token);
               }
          }

          GetRCLine("kclockDispRect", tmpString, sizeof(tmpString)/sizeof(char), "0 0 0 0");
          StrToRect(tmpString, &(this->display), this->w, this->h);

     }

     itoa(x, cX, 10);
     LSSetVariable("kclockX", cX);

     itoa(y, cY, 10);
     LSSetVariable("kclockY", cY);

     itoa(w, cW, 10);
     LSSetVariable("kclockWidth", cW);

     itoa(h, cH, 10);
     LSSetVariable("kclockHeight", cH);

     if ( IsWindow(kWnd) )
          MoveWindow(kWnd, x, y, w, h, true);
     else
          MessageBox(NULL, "kWnd is an invalid window handle.", "Error: kClock2", 32);
}

void kclock::kclockRightClick(HWND caller, LPCSTR args) {
     if ( rightClick )
          LSExecute(NULL, rightClick, 0);
}

void kclock::kclockSet(HWND caller, LPCSTR argsC) {
     char setting[64], value[64]="\0";
     char *token[1];
     int i;

     token[0] = setting;

     LCTokenize(argsC, token, 1, value);

     if ( token ) {
          for ( i=0; i<sizeof(SetFunctionsTable) / sizeof(SetFunctions); i++ ) {
               if ( !strcmp(strlwr(SetFunctionsTable[i].setting), strlwr(setting)) ) {
                    (*SetFunctionsTable[i].function)((LPCSTR)value);
               }
          }
     }

}


void kclock::kclockShow(HWND caller, LPCSTR args) {
     if ( !IsWindowVisible(kWnd) ) {
          ShowWindow(kWnd, SW_SHOWNOACTIVATE);
          hidden = false;
     }
}


void kclock::kclockToggle(HWND caller, LPCSTR args) {
     if ( IsWindowVisible(kWnd) )
          kclockHide(caller, args);
     else
          kclockShow(caller, args);
}


void kclock::kclockForceUpdate(HWND caller, LPCSTR args) {
     if ( !strcmp(strlwr((char*)args), "full") )
          InvalidateRect(kWnd, NULL, true);
     else
          InvalidateRect(kWnd, NULL, false);
}




// Setting member functions of kclock
void kclock::SetBack(LPCSTR args) {
     char tmpString[MAX_PATH]/*, *token*/;
     int bw, bh;

     delete backFile;
     DeleteObject(backBmp);
     DeleteObject(kRgn);

     backFile = new char[strlen(args)+1];
     strcpy(backFile, args);

     backBmp = LoadLSImage(backFile, NULL);

     if ( backBmp ) {
          kRgn = BitmapToRegion(backBmp, RGB(255, 0, 255), 0x101010, 0, 0);
          SetWindowRgn(kWnd, kRgn, true);
          if ( !bmpStretch && !bmpTile ) {
               GetLSBitmapSize(backBmp, &bw, &bh);
               w = bw;
               h = bh;
               MoveWindow(kWnd, x, y, w, h, false);
               

               GetRCLine("kclockDispRect", tmpString, sizeof(tmpString)/sizeof(char), "0 0 0 0");
               StrToRect(tmpString, &(this->display), this->w, this->h);
          }
     }

     else {
          backFile = NULL;
          backBmp = NULL;
          kRgn = NULL;
          SetWindowRgn(kWnd, NULL, true);
     }

     InvalidateRect(kWnd, NULL, true);
}


void kclock::SetBgColor(LPCSTR args) {
     char *color;

     color = new char[strlen(args)+1];
     strcpy(color, args);

     if ( strlen(color) == 6 ) {
          if ( bgColor == bgColorTo )
               bgColorTo = StrToCR(color, true);
          bgColor = StrToCR(color, true);
          InvalidateRect(kWnd, NULL, true);
     }
}


void kclock::SetBgColorTo(LPCSTR args) {
     char *color;

     color = new char[strlen(args)+1];
     strcpy(color, args);

     if ( strlen(color) == 6 ) {
          bgColorTo = StrToCR(color, true);
          InvalidateRect(kWnd, NULL, true);
     }
}


void kclock::SetColor(LPCSTR args) {
     char *color;

     color = new char[strlen(args)+1];
     strcpy(color, args);

     if ( strlen(color) == 6 ) {
          textColor = StrToCR(color, true);
          InvalidateRect(kWnd, NULL, true);
     }
}


void kclock::SetFormat(LPCSTR args) {
     delete format;
     format = new char[strlen(args)+1];
     strcpy(format, args);

     if ( strstr(format, "\\n") )
          ReplaceStr(format, "\\n", "\n");

     InvalidateRect(kWnd, NULL, false);
}


void kclock::SetHilight(LPCSTR argsC) {
     char *args;

     args = new char[strlen(argsC)+1];
     strcpy(args, argsC);

     if ( strlen(args) == 6 ) {
          hilightColor = StrToCR(args, true);
          InvalidateRect(kWnd, NULL, true);
     }
}


void kclock::SetLeftClick(LPCSTR args) {
     delete leftClick;
     leftClick = new char[strlen(args)+1];
     strcpy(leftClick, args);
}


void kclock::SetMiddleClick(LPCSTR args) {
     delete middleClick;
     middleClick = new char[strlen(args)+1];
     strcpy(middleClick, args);
}


void kclock::SetRightClick(LPCSTR args) {
     delete rightClick;
     rightClick = new char[strlen(args)+1];
     strcpy(rightClick, args);
}


void kclock::SetShadow(LPCSTR argsC) {
     char *args;

     args = new char[strlen(argsC)+1];
     strcpy(args, argsC);

     if ( strlen(args) == 6 ) {
          shadowColor = StrToCR(args, true);
          InvalidateRect(kWnd, NULL, true);
     }
}


void kclock::SetTextShadow(LPCSTR argsC) {
     char *args;

     args = new char[strlen(argsC)+1];
     strcpy(args, argsC);

     if ( !strcmp(strlwr(args), "true") )
          textShadow = true;
     else
          textShadow = false;

     InvalidateRect(kWnd, NULL, true);
}


void kclock::SetTextShadowClr(LPCSTR argsC) {
     char *args;

     args = new char[strlen(argsC)+1];
     strcpy(args, argsC);

     if ( strlen(args) == 6 ) {
          textShadowColor = StrToCR(args, true);
          InvalidateRect(kWnd, NULL, true);
     }
}


void kclock::SetTextShadowOff(LPCSTR args) {
     textShadowOff = atoi(args);
     InvalidateRect(kWnd, NULL, true);
}


void kclock::SetOnTop(LPCSTR args) {
     if ( !strcmp(strlwr((char*)args), "true") ) {
          onBottom = false;
          onTop = true;

          SetWindowLong(kWnd, GWL_EXSTYLE, GetWindowLong(kWnd, GWL_EXSTYLE) | WS_EX_TOPMOST);
          SetWindowLong(kWnd, GWL_STYLE, (GetWindowLong(kWnd, GWL_STYLE) & ~WS_CHILD) | WS_POPUP);
     }
     else {
          onTop = false;
          SetWindowLong(kWnd, GWL_EXSTYLE, WS_EX_TOOLWINDOW);
     }

     SetWindowPos(kWnd, (onTop ? HWND_TOPMOST : HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
}


void kclock::SetOnBottom(LPCSTR args) {
     if ( !strcmp(strlwr((char*)args), "true") ) {
          onTop = false;
          onBottom = true;

          SetWindowLong(kWnd, GWL_EXSTYLE, WS_EX_TOOLWINDOW);
          SetWindowLong(kWnd, GWL_STYLE, WS_CHILD | WS_POPUP);
     }
     else {
          onBottom = false;
          SetWindowLong(kWnd, GWL_STYLE, (GetWindowLong(kWnd, GWL_STYLE) & ~WS_CHILD) | WS_POPUP);
     }

     SetWindowPos(kWnd, (onBottom ? HWND_NOTOPMOST : HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
}


void kclock::SetTimeChange(LPCSTR args) {
     timeChange = atoi(args);
     InvalidateRect(kWnd, NULL, true);
}


void kclock::SetMouseEnter(LPCSTR args) {
     delete mouseEnter;
     mouseEnter = new char[strlen(args)+1];
     strcpy(mouseEnter, args);
}


void kclock::SetMouseExit(LPCSTR args) {
     delete mouseExit;
     mouseExit = new char[strlen(args)+1];
     strcpy(mouseExit, args);
}


void kclock::SetBorderDrag(LPCSTR args) {
     if ( !strcmp(strlwr((char*)args), "false") || !strcmp(strlwr((char*)args), "0") )
          this->borderDrag = false;
     else
          this->borderDrag = true;
}


void kclock::SetDispRect(LPCSTR args) {
     StrToRect((char*)args, &(this->display), this->w, this->h);
     InvalidateRect(kWnd, NULL, false);
}