#ifndef KCLOCK_H
#define KCLOCK_H

#define TIMER_UPDATE 1

typedef void (*FUNCPTR)(LPCSTR);

typedef struct SetFunctionsTAG {
	char* setting;
	FUNCPTR function;
} SetFunctions;

LRESULT CALLBACK kProc(HWND, UINT, WPARAM, LPARAM);

class kclock {
public:
     kclock(HINSTANCE, int&);
     ~kclock();
     void Config();
     void ConfigFuncTable();
     void RegisterBangs();

     void onCreate(HWND, WPARAM, LPARAM);
     int  onDestroy(HWND, WPARAM, LPARAM);
     void onPaint(HWND, WPARAM, LPARAM);
     void onTimer(HWND, WPARAM, LPARAM);
     void onLeftBtnDown(HWND, WPARAM, LPARAM);
     void onLeftBtnUp(HWND, WPARAM, LPARAM);
     void onRightBtnDown(HWND, WPARAM, LPARAM);
     void onRightBtnUp(HWND, WPARAM, LPARAM);
     void onMiddleBtnDown(HWND, WPARAM, LPARAM);
     void onMiddleBtnUp(HWND, WPARAM, LPARAM);
     void onMouseMove(HWND, WPARAM, LPARAM);
     void onGetRevId(HWND, WPARAM, LPARAM);
     void onRefresh(HWND, WPARAM, LPARAM);

     void kclockBoxHook(HWND, LPCSTR);
     void kclockExecute(HWND, LPCSTR);
     void kclockHide(HWND, LPCSTR);
     void kclockLeftClick(HWND, LPCSTR);
     void kclockMiddleClick(HWND, LPCSTR);
     void kclockMove(HWND, LPCSTR);
     void kclockRightClick(HWND, LPCSTR);
     void kclockSet(HWND, LPCSTR);
     void kclockShow(HWND, LPCSTR);
     void kclockToggle(HWND, LPCSTR);
     void kclockForceUpdate(HWND, LPCSTR);

     void SetBack(LPCSTR);
     void SetBgColor(LPCSTR);
     void SetBgColorTo(LPCSTR);
     void SetColor(LPCSTR);
     void SetFormat(LPCSTR);
     void SetHilight(LPCSTR);
     void SetLeftClick(LPCSTR);
     void SetMiddleClick(LPCSTR);
     void SetRightClick(LPCSTR);
     void SetShadow(LPCSTR);
     void SetTextShadow(LPCSTR);
     void SetTextShadowClr(LPCSTR);
     void SetTextShadowOff(LPCSTR);
     void SetOnTop(LPCSTR);
     void SetOnBottom(LPCSTR);
     void SetTimeChange(LPCSTR);
     void SetMouseEnter(LPCSTR);
     void SetMouseExit(LPCSTR);
     void SetBorderDrag(LPCSTR);
     void SetDispRect(LPCSTR);


private:

     bool hidden, onTop, onBottom, textShadow, textBold, textItalic, bmpStretch,
          bmpTile, transText, borderDrag, mouseDrag, mouseOver, waitForBox, inBox;
     char *format, *gradType, *fontFace, *leftClick, *rightClick, *middleClick,
          *mouseEnter, *mouseExit, *backFile;
     int x, y, w, h, bw, bh, textJustify, rotateI, fontHeight, textShadowOff,
          winStyle, interval, timeChange;
     COLORREF bgColor, bgColorTo, hilightColor, shadowColor, textColor, textShadowColor;
     HBITMAP backBmp;
     HFONT hFont;
     RECT border, display, client;
     POINT mousePos;
     HRGN kRgn;
     HWND kWnd, desktopWnd;
     HINSTANCE dllInst;
	void (*SetFunction)(char*);
	SetFunctions SetFunctionsTable[20];
     void deleteObjects();
};

extern kclock* kClock;

#endif /* KCLOCK_H */